
stages:
  - docker-setup
  - tests
  - pages


# Global
#########

image: tmaier/docker-compose:latest # TODO

services:
  - docker:dind

before_script:
  - apk add git make  # TODO : create our own ci docker image
  - make docker-login-ci

variables:
  # GIT_STRATEGY: clone
  # cf. https://gitlab.com/gitlab-org/gitlab-runner/issues/4501
  DOCKER_TLS_CERTDIR: ""

cache:
  # separate cache per branch
  key: $CI_COMMIT_REF_NAME
  untracked: true
  paths:
    - target


# Stages
#########

deploy docker image:
  stage: docker-setup
  when: manual
  script:
    - make docker-info
    - make docker-deploy

tests job:
  stage: tests
  script:
    - make dev-start
    - make dev-test
    - make dev-coverage
  coverage: '/^\d+.\d+% coverage/'

pages:
  stage: pages
  script:
    - make dev-start
    - make clean-project
    - make dev-coverage
    - make dev-doc
  coverage: '/^\d+.\d+% coverage/'
  artifacts:
    paths:
      - public
  only:
    - master
